#ifndef _FRAMEWORK_H
#define _FRAMEWORK_H
 
#include "vector.h"
#include "glincl.h"
#include "SDL_events.h"

#include "gui_gtk.h"


#define DATA_DIRECTORY "~/svn/data/"
#define MOUSE_BUTTON_COUNT 8

class Camera;

class Framework {
 private:
  Framework();
  static Framework* singletonRef;
  
  Camera* camera;
  
  bool isFinished;

  int movement [4];
  
  Uint32 lastFrame;
  Uint32 currFrame;
    
  Uint8* keys;        // This variable will be used in the keyboard routine
  bool mouseDown[MOUSE_BUTTON_COUNT];

 public:
  ~Framework(); 
  
  static Framework* getInstance(void);


  void moduleInit();
  void moduleInitGui(void);
  void moduleEventHandler(SDL_Event* event);
  void moduleTick(float dt);
  void moduleDraw(float dt);
  
  void moduleHelp(void) const;



  static void* mainLoop(void* tmp);
  bool draw(float dt);
  float tick();
  bool eventHandler();
  void quit();

  static void* mainloopGui(void* tmp);

  void printHelp(void) const;
};

int quitGui(GtkWidget* widget, void* data);


#endif /* _FRAMEWORK_H */
